open Types
open Globals
open Mpi

let kind_ai_cmd = Solvers_path.kind_ai_path
let args = " -seq -online -verbose-level -1 "

let main filename =
  if kind_ai_cmd = "undefined" then 
    ()
  else (
  let (proc_stdout, proc_stdin, proc_sterr) as proc = 
    Unix.open_process_full (kind_ai_cmd ^ args ^ filename) [||] in
  begin
    try
      while true do
	begin
	  let new_inv = input_line proc_stdout in
	  Format.fprintf Format.str_formatter 
	    "(define ASSERTIONS-INV :: (-> _nat bool) (lambda ( _M::nat) (ite (= _M _base) true %s)))" new_inv;
	  let invariant = Format.flush_str_formatter () in  
	  let s_invariant = INV_FULL(invariant) in 
	  Mpi.send s_invariant step_proc 89 comm_world
	end;
      done
  with End_of_file -> (
    let proc_status = Unix.close_process_full proc in
    exit 0)
  end
  )
    
